import { AbstractRepository } from '@crosslab/service-common';
import { InstantiableBrowserDeviceModel } from '../../model.js';
export class InstantiableBrowserDeviceRepository extends AbstractRepository {
    dependencies = {};
    constructor() {
        super('Instantiable Browser Device');
    }
    dependenciesMet() {
        if (!this.dependencies.deviceOverview)
            return false;
        return true;
    }
    initialize(entityManager) {
        this.repository = entityManager.getRepository(InstantiableBrowserDeviceModel);
    }
    async create(data) {
        const model = await super.create(data);
        model.type = 'edge instantiable';
        return model;
    }
    async write(model, data) {
        if (!this.isInitialized())
            this.throwUninitializedRepositoryError();
        await this.dependencies.deviceOverview.write(model, data);
        if (data.codeUrl)
            model.codeUrl = data.codeUrl;
        if (data.services)
            model.services = data.services;
    }
    async format(model) {
        if (!this.isInitialized())
            this.throwUninitializedRepositoryError();
        return {
            ...(await this.dependencies.deviceOverview.format(model)),
            type: 'edge instantiable',
            codeUrl: model.codeUrl,
            services: model.services ?? undefined,
        };
    }
}
//# sourceMappingURL=instantiableBrowserDevice.js.map